"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.newSubschemaContext = newSubschemaContext;
exports.default = exports.loader = exports.importer = exports.valueManager = exports.ValueManager = exports.Form = void 0;

var _autoloader = _interopRequireDefault(require("./autoloader"));

var _importer2 = _interopRequireDefault(require("./importer"));

var _subschemaContext = _interopRequireDefault(require("subschema-context"));

function newSubschemaContext() {
  var defaultLoaders = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [_autoloader.default];
  var defaultInjectionFactory = arguments.length > 1 ? arguments[1] : undefined;
  var defaultValueManagerFactory = arguments.length > 2 ? arguments[2] : undefined;
  var ctx = (0, _subschemaContext.default)(defaultLoaders, defaultInjectionFactory, defaultValueManagerFactory);
  ctx.importer = (0, _importer2.default)({
    react: require('react'),
    'subschema': ctx,
    'react-dom': require('react-dom'),
    'subschema-context': require('subschema-context'),
    'subschema-css': require('subschema-css'),
    'subschema-dom': require('subschema-dom'),
    'subschema-expression': require('subschema-expression'),
    'subschema-field': require('subschema-field'),
    'subschema-fieldset': require('subschema-fieldset'),
    'subschema-form': require('subschema-form'),
    'subschema-injection': require('subschema-injection'),
    'subschema-loader': require('subschema-loader'),
    'subschema-prop-types': require('subschema-prop-types'),
    'subschema-rendercontent': require('subschema-rendercontent'),
    'subschema-rendertemplate': require('subschema-rendertemplate'),
    'subschema-utils': require('subschema-utils'),
    'subschema-valuemanager': require('subschema-valuemanager')
  });
  return ctx;
}

var def = newSubschemaContext();
var Form = def.Form;
exports.Form = Form;
var ValueManager = def.ValueManager;
exports.ValueManager = ValueManager;
var valueManager = def.valueManager;
exports.valueManager = valueManager;
var importer = def.importer;
exports.importer = importer;
var loader = def.loader;
exports.loader = loader;
var _default = def;
exports.default = _default;
//# sourceMappingURL=index.js.map